Index: /pykota/branches/1.26_fixes/pykota/storages/ldapstorage.py
===================================================================
--- /pykota/branches/1.26_fixes/pykota/storages/ldapstorage.py (revision 3184)
+++ /pykota/branches/1.26_fixes/pykota/storages/ldapstorage.py (revision 3522)
@@ -744,5 +732,5 @@
                     user.Email = fields.get(self.info["usermail"], [None])[0]
                     user.LimitBy = fields.get("pykotaLimitBy", ["quota"])[0]
-                    user.Description = self.databaseToUserCharset(fields.get("description", [""])[0]) 
+                    user.Description = self.databaseToUserCharset(fields.get("description", [""])[0])
                     uname = self.userCharsetToDatabase(username)
                     result = self.doSearch("(&(objectClass=pykotaAccountBalance)(|(pykotaUserName=%s)(%s=%s)))" % \
@@ -760,14 +748,14 @@
                             if user.AccountBalance[0].upper() == "NONE" :
                                 user.AccountBalance = None
-                            else :    
+                            else :
                                 user.AccountBalance = float(user.AccountBalance[0])
-                        user.AccountBalance = user.AccountBalance or 0.0        
+                        user.AccountBalance = user.AccountBalance or 0.0
                         user.LifeTimePaid = fields.get("pykotaLifeTimePaid")
                         if user.LifeTimePaid is not None :
                             if user.LifeTimePaid[0].upper() == "NONE" :
                                 user.LifeTimePaid = None
-                            else :    
+                            else :
                                 user.LifeTimePaid = float(user.LifeTimePaid[0])
-                        user.LifeTimePaid = user.LifeTimePaid or 0.0        
+                        user.LifeTimePaid = user.LifeTimePaid or 0.0
                         user.Payments = []
                         for payment in fields.get("pykotaPayments", []) :
@@ -778,5 +766,5 @@
                                 (date, amount) = payment.split(" # ")
                                 description = ""
-                            else :    
+                            else :
                                 description = self.databaseToUserCharset(base64.decodestring(description))
                             user.Payments.append((date, float(amount), description))
@@ -784,6 +772,6 @@
                     users.append(user)
                     self.cacheEntry("USERS", user.Name, user)
-        return users       
-        
+        return users
+
     def getMatchingGroups(self, grouppattern) :
         """Returns the list of all groups for which name matches a certain pattern."""
@@ -795,11 +783,5 @@
         if result :
             patterns = grouppattern.split(",")
-            try :
-                patdict = {}.fromkeys(patterns)
-            except AttributeError :    
-                # Python v2.2 or earlier
-                patdict = {}
-                for p in patterns :
-                    patdict[p] = None
+            patdict = {}.fromkeys(patterns)
             for (groupid, fields) in result :
                 groupname = self.databaseToUserCharset(fields.get("pykotaGroupName", [""])[0] or fields.get(self.info["grouprdn"], [""])[0])
@@ -807,7 +789,7 @@
                     group = StorageGroup(self, groupname)
                     group.ident = groupid
-                    group.Name = fields.get("pykotaGroupName", [self.databaseToUserCharset(groupname)])[0] 
+                    group.Name = fields.get("pykotaGroupName", [self.databaseToUserCharset(groupname)])[0]
                     group.LimitBy = fields.get("pykotaLimitBy", ["quota"])[0]
-                    group.Description = self.databaseToUserCharset(fields.get("description", [""])[0]) 
+                    group.Description = self.databaseToUserCharset(fields.get("description", [""])[0])
                     group.AccountBalance = 0.0
                     group.LifeTimePaid = 0.0
@@ -820,6 +802,6 @@
                     self.cacheEntry("GROUPS", group.Name, group)
         return groups
-        
-    def getPrinterUsersAndQuotas(self, printer, names=["*"]) :        
+
+    def getPrinterUsersAndQuotas(self, printer, names=["*"]) :
         """Returns the list of users who uses a given printer, along with their quotas."""
         usersandquotas = []
@@ -846,5 +828,5 @@
                     if userpquota.SoftLimit[0].upper() == "NONE" :
                         userpquota.SoftLimit = None
-                    else :    
+                    else :
                         userpquota.SoftLimit = int(userpquota.SoftLimit[0])
                 userpquota.HardLimit = fields.get("pykotaHardLimit")
@@ -852,19 +834,19 @@
                     if userpquota.HardLimit[0].upper() == "NONE" :
                         userpquota.HardLimit = None
-                    elif userpquota.HardLimit is not None :    
+                    elif userpquota.HardLimit is not None :
                         userpquota.HardLimit = int(userpquota.HardLimit[0])
                 userpquota.DateLimit = fields.get("pykotaDateLimit")
                 if userpquota.DateLimit is not None :
-                    if userpquota.DateLimit[0].upper() == "NONE" : 
+                    if userpquota.DateLimit[0].upper() == "NONE" :
                         userpquota.DateLimit = None
-                    else :    
+                    else :
                         userpquota.DateLimit = userpquota.DateLimit[0]
                 userpquota.Exists = True
                 usersandquotas.append((user, userpquota))
                 self.cacheEntry("USERPQUOTAS", "%s@%s" % (user.Name, printer.Name), userpquota)
-        usersandquotas.sort(lambda x, y : cmp(x[0].Name, y[0].Name))            
+        usersandquotas.sort(lambda x, y : cmp(x[0].Name, y[0].Name))
         return usersandquotas
-                
-    def getPrinterGroupsAndQuotas(self, printer, names=["*"]) :        
+
+    def getPrinterGroupsAndQuotas(self, printer, names=["*"]) :
         """Returns the list of groups which uses a given printer, along with their quotas."""
         groupsandquotas = []
@@ -884,7 +866,7 @@
                 grouppquota = self.getGroupPQuota(group, printer)
                 groupsandquotas.append((group, grouppquota))
-        groupsandquotas.sort(lambda x, y : cmp(x[0].Name, y[0].Name))            
+        groupsandquotas.sort(lambda x, y : cmp(x[0].Name, y[0].Name))
         return groupsandquotas
-        
+
     def addPrinter(self, printer) :
         """Adds a printer to the quota storage, returns the old value if it already exists."""
@@ -902,11 +884,11 @@
                    "pykotaPricePerPage" : str(printer.PricePerPage or 0.0),
                    "pykotaPricePerJob" : str(printer.PricePerJob or 0.0),
-                 } 
+                 }
         dn = "%s=%s,%s" % (self.info["printerrdn"], printername, self.info["printerbase"])
         self.doAdd(dn, fields)
         printer.isDirty = False
         return None # the entry created doesn't need further modification
-        
-    def addUser(self, user) :        
+
+    def addUser(self, user) :
         """Adds a user to the quota storage, returns the old value if it already exists."""
         oldentry = self.getUser(user.Name)
@@ -919,6 +901,6 @@
                        "description" : self.userCharsetToDatabase(user.Description or ""),
                        self.info["usermail"] : user.Email or "",
-                    }   
-                       
+                    }
+
         mustadd = 1
         if self.info["newuser"].lower() != 'below' :
@@ -938,16 +920,16 @@
                 fields.update({ "pykotaBalance" : str(user.AccountBalance or 0.0),
                                 "pykotaOverCharge" : str(user.OverCharge),
-                                "pykotaLifeTimePaid" : str(user.LifeTimePaid or 0.0), })   
+                                "pykotaLifeTimePaid" : str(user.LifeTimePaid or 0.0), })
                 self.doModify(dn, fields)
                 mustadd = 0
             else :
                 message = _("Unable to find an existing objectClass %s entry with %s=%s to attach pykotaAccount objectClass") % (where, self.info["userrdn"], user.Name)
-                if action.lower() == "warn" :    
+                if action.lower() == "warn" :
                     self.tool.printInfo(_("%s. A new entry will be created instead.") % message, "warn")
                 else : # 'fail' or incorrect setting
                     raise PyKotaStorageError, "%s. Action aborted. Please check your configuration." % message
-                
+
         if mustadd :
-            if self.info["userbase"] == self.info["balancebase"] :            
+            if self.info["userbase"] == self.info["balancebase"] :
                 fields = { self.info["userrdn"] : uname,
                            "objectClass" : ["pykotaObject", "pykotaAccount", "pykotaAccountBalance"],
@@ -955,15 +937,15 @@
                            "pykotaBalance" : str(user.AccountBalance or 0.0),
                            "pykotaOverCharge" : str(user.OverCharge),
-                           "pykotaLifeTimePaid" : str(user.LifeTimePaid or 0.0), 
-                         } 
-            else :             
+                           "pykotaLifeTimePaid" : str(user.LifeTimePaid or 0.0),
+                         }
+            else :
                 fields = { self.info["userrdn"] : uname,
                            "objectClass" : ["pykotaObject", "pykotaAccount"],
                            "cn" : uname,
-                         } 
-            fields.update(newfields)         
+                         }
+            fields.update(newfields)
             dn = "%s=%s,%s" % (self.info["userrdn"], uname, self.info["userbase"])
             self.doAdd(dn, fields)
-            if self.info["userbase"] != self.info["balancebase"] :            
+            if self.info["userbase"] != self.info["balancebase"] :
                 fields = { self.info["balancerdn"] : uname,
                            "objectClass" : ["pykotaObject", "pykotaAccountBalance"],
@@ -971,6 +953,6 @@
                            "pykotaBalance" : str(user.AccountBalance or 0.0),
                            "pykotaOverCharge" : str(user.OverCharge),
-                           "pykotaLifeTimePaid" : str(user.LifeTimePaid or 0.0),  
-                         } 
+                           "pykotaLifeTimePaid" : str(user.LifeTimePaid or 0.0),
+                         }
                 dn = "%s=%s,%s" % (self.info["balancerdn"], uname, self.info["balancebase"])
                 self.doAdd(dn, fields)
@@ -982,6 +964,6 @@
         user.isDirty = False
         return None # the entry created doesn't need further modification
-        
-    def addGroup(self, group) :        
+
+    def addGroup(self, group) :
         """Adds a group to the quota storage, returns the old value if it already exists."""
         oldentry = self.getGroup(group.Name)
@@ -989,9 +971,9 @@
             return oldentry # we return the existing entry
         gname = self.userCharsetToDatabase(group.Name)
-        newfields = { 
+        newfields = {
                       "pykotaGroupName" : gname,
                       "pykotaLimitBy" : (group.LimitBy or "quota"),
                       "description" : self.userCharsetToDatabase(group.Description or "")
-                    } 
+                    }
         mustadd = 1
         if self.info["newgroup"].lower() != 'below' :
@@ -1013,24 +995,24 @@
             else :
                 message = _("Unable to find an existing entry to attach pykotaGroup objectclass %s") % group.Name
-                if action.lower() == "warn" :    
+                if action.lower() == "warn" :
                     self.tool.printInfo("%s. A new entry will be created instead." % message, "warn")
                 else : # 'fail' or incorrect setting
                     raise PyKotaStorageError, "%s. Action aborted. Please check your configuration." % message
-                
+
         if mustadd :
             fields = { self.info["grouprdn"] : gname,
                        "objectClass" : ["pykotaObject", "pykotaGroup"],
                        "cn" : gname,
-                     } 
-            fields.update(newfields)         
+                     }
+            fields.update(newfields)
             dn = "%s=%s,%s" % (self.info["grouprdn"], gname, self.info["groupbase"])
             self.doAdd(dn, fields)
         group.isDirty = False
         return None # the entry created doesn't need further modification
-        
-    def addUserToGroup(self, user, group) :    
+
+    def addUserToGroup(self, user, group) :
         """Adds an user to a group."""
         if user.Name not in [u.Name for u in self.getGroupMembers(group)] :
-            result = self.doSearch("objectClass=pykotaGroup", None, base=group.ident, scope=ldap.SCOPE_BASE)    
+            result = self.doSearch("objectClass=pykotaGroup", None, base=group.ident, scope=ldap.SCOPE_BASE)
             if result :
                 fields = result[0][1]
@@ -1040,6 +1022,6 @@
                 self.doModify(group.ident, fields)
                 group.Members.append(user)
-                
-    def delUserFromGroup(self, user, group) :    
+
+    def delUserFromGroup(self, user, group) :
         """Removes an user from a group."""
         if user.Name in [u.Name for u in self.getGroupMembers(group)] :
@@ -1049,5 +1031,5 @@
                 if not fields.has_key(self.info["groupmembers"]) :
                     fields[self.info["groupmembers"]] = []
-                try :    
+                try :
                     fields[self.info["groupmembers"]].remove(self.userCharsetToDatabase(user.Name))
                 except ValueError :
@@ -1056,5 +1038,5 @@
                     self.doModify(group.ident, fields)
                     group.Members.remove(user)
-                
+
     def addUserPQuota(self, upq) :
         """Initializes a user print quota on a printer."""
@@ -1077,13 +1059,13 @@
                    "pykotaWarnCount" : str(upq.WarnCount or 0),
                    "pykotaMaxJobSize" : str(upq.MaxJobSize or 0),
-                 } 
+                 }
         if self.info["userquotabase"].lower() == "user" :
             dn = "cn=%s,%s" % (uuid, upq.User.ident)
-        else :    
+        else :
             dn = "cn=%s,%s" % (uuid, self.info["userquotabase"])
         self.doAdd(dn, fields)
         upq.isDirty = False
         return None # the entry created doesn't need further modification
-        
+
     def addGroupPQuota(self, gpq) :
         """Initializes a group print quota on a printer."""
@@ -1099,14 +1081,14 @@
                    "pykotaPrinterName" : pname,
                    "pykotaDateLimit" : "None",
-                 } 
+                 }
         if self.info["groupquotabase"].lower() == "group" :
             dn = "cn=%s,%s" % (uuid, gpq.Group.ident)
-        else :    
+        else :
             dn = "cn=%s,%s" % (uuid, self.info["groupquotabase"])
         self.doAdd(dn, fields)
         gpq.isDirty = False
         return None # the entry created doesn't need further modification
-        
-    def savePrinter(self, printer) :    
+
+    def savePrinter(self, printer) :
         """Saves the printer to the database in a single operation."""
         fields = {
@@ -1118,29 +1100,29 @@
                  }
         self.doModify(printer.ident, fields)
-        
+
     def saveUser(self, user) :
         """Saves the user to the database in a single operation."""
         newfields = {
                        "pykotaLimitBy" : (user.LimitBy or "quota"),
-                       "description" : self.userCharsetToDatabase(user.Description or ""), 
+                       "description" : self.userCharsetToDatabase(user.Description or ""),
                        self.info["usermail"] : user.Email or "",
-                    }   
+                    }
         self.doModify(user.ident, newfields)
-        
+
         newfields = { "pykotaBalance" : str(user.AccountBalance or 0.0),
-                      "pykotaLifeTimePaid" : str(user.LifeTimePaid or 0.0), 
+                      "pykotaLifeTimePaid" : str(user.LifeTimePaid or 0.0),
                       "pykotaOverCharge" : str(user.OverCharge),
                     }
         self.doModify(user.idbalance, newfields)
-        
+
     def saveGroup(self, group) :
         """Saves the group to the database in a single operation."""
         newfields = {
                        "pykotaLimitBy" : (group.LimitBy or "quota"),
-                       "description" : self.userCharsetToDatabase(group.Description or ""), 
-                    }   
+                       "description" : self.userCharsetToDatabase(group.Description or ""),
+                    }
         self.doModify(group.ident, newfields)
-        
-    def writeUserPQuotaDateLimit(self, userpquota, datelimit) :    
+
+    def writeUserPQuotaDateLimit(self, userpquota, datelimit) :
         """Sets the date limit permanently for a user print quota."""
         fields = {
@@ -1148,6 +1130,6 @@
                  }
         return self.doModify(userpquota.ident, fields)
-            
-    def writeGroupPQuotaDateLimit(self, grouppquota, datelimit) :    
+
+    def writeGroupPQuotaDateLimit(self, grouppquota, datelimit) :
         """Sets the date limit permanently for a group print quota."""
         fields = {
@@ -1155,6 +1137,6 @@
                  }
         return self.doModify(grouppquota.ident, fields)
-        
-    def increaseUserPQuotaPagesCounters(self, userpquota, nbpages) :    
+
+    def increaseUserPQuotaPagesCounters(self, userpquota, nbpages) :
         """Increase page counters for a user print quota."""
         fields = {
@@ -1162,13 +1144,13 @@
                    "pykotaLifePageCounter" : { "operator" : "+", "value" : nbpages, "convert" : int },
                  }
-        return self.doModify(userpquota.ident, fields)         
-        
-    def decreaseUserAccountBalance(self, user, amount) :    
+        return self.doModify(userpquota.ident, fields)
+
+    def decreaseUserAccountBalance(self, user, amount) :
         """Decreases user's account balance from an amount."""
         fields = {
                    "pykotaBalance" : { "operator" : "-", "value" : amount, "convert" : float },
                  }
-        return self.doModify(user.idbalance, fields, flushcache=1)         
-       
+        return self.doModify(user.idbalance, fields, flushcache=1)
+
     def writeNewPayment(self, user, amount, comment="") :
         """Adds a new payment to the payments history."""
@@ -1180,7 +1162,7 @@
                    "pykotaPayments" : payments,
                  }
-        return self.doModify(user.idbalance, fields)         
-        
-    def writeLastJobSize(self, lastjob, jobsize, jobprice) :        
+        return self.doModify(user.idbalance, fields)
+
+    def writeLastJobSize(self, lastjob, jobsize, jobprice) :
         """Sets the last job's size permanently."""
         fields = {
@@ -1188,6 +1170,6 @@
                    "pykotaJobPrice" : str(jobprice),
                  }
-        self.doModify(lastjob.ident, fields)         
-        
+        self.doModify(lastjob.ident, fields)
+
     def writeJobNew(self, printer, user, jobid, pagecounter, action, jobsize=None, jobprice=None, filename=None, title=None, copies=None, options=None, clienthost=None, jobsizebytes=None, jobmd5sum=None, jobpages=None, jobbilling=None, precomputedsize=None, precomputedprice=None) :
         """Adds a job in a printer's history."""
@@ -1197,8 +1179,8 @@
             uuid = self.genUUID()
             dn = "cn=%s,%s" % (uuid, self.info["jobbase"])
-        else :    
+        else :
             uuid = printer.LastJob.ident[3:].split(",")[0]
             dn = printer.LastJob.ident
-        if self.privacy :    
+        if self.privacy :
             # For legal reasons, we want to hide the title, filename and options
             title = filename = options = "hidden"
@@ -1211,9 +1193,9 @@
                    "pykotaPrinterPageCounter" : str(pagecounter),
                    "pykotaAction" : action,
-                   "pykotaFileName" : ((filename is None) and "None") or self.userCharsetToDatabase(filename), 
-                   "pykotaTitle" : ((title is None) and "None") or self.userCharsetToDatabase(title), 
-                   "pykotaCopies" : str(copies), 
-                   "pykotaOptions" : ((options is None) and "None") or self.userCharsetToDatabase(options), 
-                   "pykotaHostName" : str(clienthost), 
+                   "pykotaFileName" : ((filename is None) and "None") or self.userCharsetToDatabase(filename),
+                   "pykotaTitle" : ((title is None) and "None") or self.userCharsetToDatabase(title),
+                   "pykotaCopies" : str(copies),
+                   "pykotaOptions" : ((options is None) and "None") or self.userCharsetToDatabase(options),
+                   "pykotaHostName" : str(clienthost),
                    "pykotaJobSizeBytes" : str(jobsizebytes),
                    "pykotaMD5Sum" : str(jobmd5sum),
@@ -1224,18 +1206,18 @@
                  }
         if (not self.disablehistory) or (not printer.LastJob.Exists) :
-            if jobsize is not None :         
+            if jobsize is not None :
                 fields.update({ "pykotaJobSize" : str(jobsize), "pykotaJobPrice" : str(jobprice) })
             self.doAdd(dn, fields)
-        else :    
+        else :
             # here we explicitly want to reset jobsize to 'None' if needed
             fields.update({ "pykotaJobSize" : str(jobsize), "pykotaJobPrice" : str(jobprice) })
             self.doModify(dn, fields)
-            
+
         if printer.LastJob.Exists :
             fields = {
                        "pykotaLastJobIdent" : uuid,
                      }
-            self.doModify(printer.LastJob.lastjobident, fields)         
-        else :    
+            self.doModify(printer.LastJob.lastjobident, fields)
+        else :
             lastjuuid = self.genUUID()
             lastjdn = "cn=%s,%s" % (lastjuuid, self.info["lastjobbase"])
@@ -1245,10 +1227,10 @@
                        "pykotaPrinterName" : pname,
                        "pykotaLastJobIdent" : uuid,
-                     }  
-            self.doAdd(lastjdn, fields)          
-            
+                     }
+            self.doAdd(lastjdn, fields)
+
     def saveUserPQuota(self, userpquota) :
         """Saves an user print quota entry."""
-        fields = { 
+        fields = {
                    "pykotaSoftLimit" : str(userpquota.SoftLimit),
                    "pykotaHardLimit" : str(userpquota.HardLimit),
@@ -1260,12 +1242,12 @@
                  }
         self.doModify(userpquota.ident, fields)
-        
+
     def writeUserPQuotaWarnCount(self, userpquota, warncount) :
         """Sets the warn counter value for a user quota."""
-        fields = { 
+        fields = {
                    "pykotaWarnCount" : str(warncount or 0),
                  }
         self.doModify(userpquota.ident, fields)
-        
+
     def increaseUserPQuotaWarnCount(self, userpquota) :
         """Increases the warn counter value for a user quota."""
@@ -1273,9 +1255,9 @@
                    "pykotaWarnCount" : { "operator" : "+", "value" : 1, "convert" : int },
                  }
-        return self.doModify(userpquota.ident, fields)         
-        
+        return self.doModify(userpquota.ident, fields)
+
     def saveGroupPQuota(self, grouppquota) :
         """Saves a group print quota entry."""
-        fields = { 
+        fields = {
                    "pykotaSoftLimit" : str(grouppquota.SoftLimit),
                    "pykotaHardLimit" : str(grouppquota.HardLimit),
@@ -1284,5 +1266,5 @@
                  }
         self.doModify(grouppquota.ident, fields)
-            
+
     def writePrinterToGroup(self, pgroup, printer) :
         """Puts a printer into a printer group."""
@@ -1291,19 +1273,19 @@
             fields = {
                        "uniqueMember" : pgroup.uniqueMember
-                     }  
-            self.doModify(pgroup.ident, fields)         
-            
+                     }
+            self.doModify(pgroup.ident, fields)
+
     def removePrinterFromGroup(self, pgroup, printer) :
         """Removes a printer from a printer group."""
         try :
             pgroup.uniqueMember.remove(printer.ident)
-        except ValueError :    
+        except ValueError :
             pass
-        else :    
+        else :
             fields = {
                        "uniqueMember" : pgroup.uniqueMember,
-                     }  
-            self.doModify(pgroup.ident, fields)         
-            
+                     }
+            self.doModify(pgroup.ident, fields)
+
     def retrieveHistory(self, user=None, printer=None, hostname=None, billingcode=None, jobid=None, limit=100, start=None, end=None) :
         """Retrieves all print jobs for user on printer (or all) between start and end date, limited to first 100 results."""
@@ -1320,28 +1302,28 @@
         if jobid is not None :
             where.append("(pykotaJobId=%s)" % jobid) # TODO : jobid is text, so self.userCharsetToDatabase(jobid) but do all of them as well.
-        if where :    
+        if where :
             where = "(&%s)" % "".join([precond] + where)
-        else :    
+        else :
             where = precond
-        jobs = []    
-        result = self.doSearch(where, fields=[ "pykotaJobSizeBytes", 
-                                               "pykotaHostName", 
-                                               "pykotaUserName", 
-                                               "pykotaPrinterName", 
-                                               "pykotaJobId", 
-                                               "pykotaPrinterPageCounter", 
-                                               "pykotaAction", 
-                                               "pykotaJobSize", 
-                                               "pykotaJobPrice", 
-                                               "pykotaFileName", 
-                                               "pykotaTitle", 
-                                               "pykotaCopies", 
-                                               "pykotaOptions", 
-                                               "pykotaBillingCode", 
-                                               "pykotaPages", 
-                                               "pykotaMD5Sum", 
+        jobs = []
+        result = self.doSearch(where, fields=[ "pykotaJobSizeBytes",
+                                               "pykotaHostName",
+                                               "pykotaUserName",
+                                               "pykotaPrinterName",
+                                               "pykotaJobId",
+                                               "pykotaPrinterPageCounter",
+                                               "pykotaAction",
+                                               "pykotaJobSize",
+                                               "pykotaJobPrice",
+                                               "pykotaFileName",
+                                               "pykotaTitle",
+                                               "pykotaCopies",
+                                               "pykotaOptions",
+                                               "pykotaBillingCode",
+                                               "pykotaPages",
+                                               "pykotaMD5Sum",
                                                "pykotaPrecomputedJobSize",
                                                "pykotaPrecomputedJobPrice",
-                                               "createTimestamp" ], 
+                                               "createTimestamp" ],
                                       base=self.info["jobbase"])
         if result :
@@ -1353,15 +1335,15 @@
                 try :
                     job.JobSize = int(fields.get("pykotaJobSize", [0])[0])
-                except ValueError :    
+                except ValueError :
                     job.JobSize = None
-                try :    
+                try :
                     job.JobPrice = float(fields.get("pykotaJobPrice", [0.0])[0])
                 except ValueError :
                     job.JobPrice = None
                 job.JobAction = fields.get("pykotaAction", [""])[0]
-                job.JobFileName = self.databaseToUserCharset(fields.get("pykotaFileName", [""])[0]) 
-                job.JobTitle = self.databaseToUserCharset(fields.get("pykotaTitle", [""])[0]) 
+                job.JobFileName = self.databaseToUserCharset(fields.get("pykotaFileName", [""])[0])
+                job.JobTitle = self.databaseToUserCharset(fields.get("pykotaTitle", [""])[0])
                 job.JobCopies = int(fields.get("pykotaCopies", [0])[0])
-                job.JobOptions = self.databaseToUserCharset(fields.get("pykotaOptions", [""])[0]) 
+                job.JobOptions = self.databaseToUserCharset(fields.get("pykotaOptions", [""])[0])
                 job.JobHostName = fields.get("pykotaHostName", [""])[0]
                 job.JobSizeBytes = fields.get("pykotaJobSizeBytes", [0L])[0]
@@ -1371,7 +1353,7 @@
                 try :
                     job.PrecomputedJobSize = int(fields.get("pykotaPrecomputedJobSize", [0])[0])
-                except ValueError :    
+                except ValueError :
                     job.PrecomputedJobSize = None
-                try :    
+                try :
                     job.PrecomputedJobPrice = float(fields.get("pykotaPrecomputedJobPrice", [0.0])[0])
                 except ValueError :
@@ -1390,13 +1372,13 @@
                     job.Exists = True
                     jobs.append(job)
-            jobs.sort(lambda x, y : cmp(y.JobDate, x.JobDate))        
-            if limit :    
+            jobs.sort(lambda x, y : cmp(y.JobDate, x.JobDate))
+            if limit :
                 jobs = jobs[:int(limit)]
         return jobs
-        
-    def deleteUser(self, user) :    
+
+    def deleteUser(self, user) :
         """Completely deletes an user from the Quota Storage."""
         uname = self.userCharsetToDatabase(user.Name)
-        todelete = []    
+        todelete = []
         result = self.doSearch("(&(objectClass=pykotaJob)(pykotaUserName=%s))" % uname, base=self.info["jobbase"])
         for (ident, fields) in result :
@@ -1412,5 +1394,5 @@
             # ensure the user print quota entry will be deleted
             todelete.append(ident)
-            
+
             # if last job of current printer was printed by the user
             # to delete, we also need to delete the printer's last job entry.
@@ -1418,9 +1400,9 @@
             if printer.LastJob.UserName == user.Name :
                 todelete.append(printer.LastJob.lastjobident)
-            
-        for ident in todelete :    
+
+        for ident in todelete :
             self.doDelete(ident)
-            
-        result = self.doSearch("objectClass=pykotaAccount", None, base=user.ident, scope=ldap.SCOPE_BASE)    
+
+        result = self.doSearch("objectClass=pykotaAccount", None, base=user.ident, scope=ldap.SCOPE_BASE)
         if result :
             fields = result[0][1]
